<?php
/**
 * Cache/Revisions Eraser admin plugin
 * Version : 1.3
 *
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author     JustBurn <justburner@hotmail.com>
 */

if(!defined('DOKU_INC')) define('DOKU_INC',realpath(dirname(__FILE__).'/../../').'/');
if(!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');
require_once(DOKU_PLUGIN.'admin.php');
define('CACHEREVISIONSERASER_VER','1.3');

/**
 * All DokuWiki plugins to extend the admin function
 * need to inherit from this class
 */
class admin_plugin_cacherevisionserase extends DokuWiki_Admin_Plugin {

    var $cachedir = null;
    var $revisdir = null;
    var $configs = null;

    /**
     * Constructor
     */
    function admin_plugin_cacherevisionserase(){
      $this->setupLocale();
      
      @include(dirname(__FILE__).'/configs.php');
    }

    /**
     * return some info
     */
    function getInfo(){
      return array(
        'author' => 'JustBurn',
        'email'  => 'justburner@hotmail.com',
        'date'   => '06-05-2006',
        'name'   => $this->lang['title'],
        'desc'   => $this->lang['desc'],
        'url'    => 'http://wiki.splitbrain.org/plugin:cacherevisionseraser',
      );
    }

    /**
     * return prompt for admin menu
     */
    function getMenuText($language) {
        return $this->lang['menu'];
    }

    /**
     * return sort order for position in admin menu
     */
    function getMenuSort() { return $this->configs['menusort']; }

    /**
     * handle user request
     */
    function handle() {
      global $conf;

      $this->cachedir = $conf['savedir'] . '/cache';
      $this->revisdir = $conf['savedir'] . '/attic';
    }

    /**
     * output appropriate html
     */
    function html() {
      global $ID;
      global $lang;
      global $cacherevercfg;

      $cmd = $_REQUEST['cmd'];
      $params = (strcmp($_REQUEST['delfl_UNK'],'yes') ? 0x01 : 0) + (strcmp($_REQUEST['del_indexing'],'yes') ? 0x02 : 0) + (strcmp($_REQUEST['delfl_i'],'yes') ? 0x04 : 0) + (strcmp($_REQUEST['delfl_xhtml'],'yes') ? 0x08 : 0) + (strcmp($_REQUEST['delfl_js'],'yes') ? 0x10 : 0) + (strcmp($_REQUEST['delfl_css'],'yes') ? 0x20 : 0) + (strcmp($_REQUEST['delfl_mediaP'],'yes') ? 0x40 : 0);
      if ($cmd == $null) $cmd = 'main';

      ptln('<h1>'.$this->lang['title'].' version '.CACHEREVISIONSERASER_VER.'</h1>');

      if (($cmd == "erasecache") && ($this->configs['allow_allcachedel'] == true)) {
        ptln('<table class="inline">');
        ptln('  <th class="leftalign">');
        if ($this->rmeverything_cache($this->cachedir, $this->cachedir, $params)) {
          ptln('  </th>');
          ptln('</table>');
          ptln('<p></p><p>'.$this->lang['successcache'].'</p>');
        } else {
          ptln('  </th>');
          ptln('</table>');
          ptln('<p></p><p>'.$this->lang['failedcache'].'</p>');
        }
        ptln('<table class="inline">');
        ptln('  <th class="centeralign">');
        ptln('    <form method="post" action="'.wl($ID).'"><div class="no">');
        ptln('    <input type="hidden" name="do"   value="admin" />');
        ptln('    <input type="hidden" name="page" value="cacherevisionserase" />');
        ptln('    <input type="hidden" name="cmd"  value="main" />');
        ptln('    <input type="submit" class="button" value="'.$this->lang['backbtn'].'" />');
        ptln('    </div></form>');
        ptln('  </th>');
        ptln('</table>');
      } else if (($cmd == "eraseallrevisions") && ($this->configs['allow_allrevisdel'] == true)) {
        ptln('<table class="inline">');
        ptln('  <th class="leftalign">');
        if ($this->rmeverything_revis($this->revisdir, $this->revisdir)) {
          ptln('  </th>');
          ptln('</table>');
          ptln('<p></p><p>'.$this->lang['successrevisions'].'</p>');
        } else {
          ptln('  </th>');
          ptln('</table>');
          ptln('<p></p><p>'.$this->lang['failedrevisions'].'</p>');
        }
        ptln('<table class="inline">');
        ptln('  <th class="centeralign">');
        ptln('    <form method="post" action="'.wl($ID).'"><div class="no">');
        ptln('    <input type="hidden" name="do"   value="admin" />');
        ptln('    <input type="hidden" name="page" value="cacherevisionserase" />');
        ptln('    <input type="hidden" name="cmd"  value="main" />');
        ptln('    <input type="submit" class="button" value="'.$this->lang['backbtn'].'" />');
        ptln('    </div></form>');
        ptln('  </th>');
        ptln('</table>');
      } else {
        ptln('<table class="inline">');
        ptln('  <tr>');
        ptln('    <th class="centeralign">');
        if ($this->configs['allow_allcachedel'] == true) {
          ptln('      <form method="post" action="'.wl($ID).'" onsubmit="return confirm(\''.str_replace('\\\\n','\\n',addslashes($this->lang['askcache'])).'\')"><div class="no">');
          ptln('      <input type="hidden" name="do"   value="admin" />');
          ptln('      <input type="hidden" name="page" value="cacherevisionserase" />');
          ptln('      <input type="hidden" name="cmd"  value="erasecache" />');
          ptln('      <p>'.$this->lang['cachedesc'].'</p>');
          ptln('      <input type="submit" class="button" value="'.$this->lang['erasecachebtn'].'" />');
          ptln('      <div class="leftalign"><p></p>');
          if ($this->configs['cache_delext_i'] < 0)
            ptln('      <input type="checkbox" name="delfl_i"  value="yes" checked />'.$this->lang['extdesc_i'].'</label><br />');
          else
            ptln('      <input type="checkbox" name="delfl_i"  value="yes" '.($this->configs['cache_delext_i'] ? 'checked' : '').' disabled />'.$this->lang['extdesc_i'].'</label><br />');
          if ($this->configs['cache_delext_xhtml'] < 0)
            ptln('      <input type="checkbox" name="delfl_xhtml"  value="yes" checked />'.$this->lang['extdesc_xhtml'].'</label><br />');
          else
            ptln('      <input type="checkbox" name="delfl_xhtml"  value="yes" '.($this->configs['cache_delext_xhtml'] ? 'checked' : '').' disabled />'.$this->lang['extdesc_xhtml'].'</label><br />');
          if ($this->configs['cache_delext_js'] < 0)
            ptln('      <input type="checkbox" name="delfl_js"  value="yes" checked />'.$this->lang['extdesc_js'].'</label><br />');
          else
            ptln('      <input type="checkbox" name="delfl_js"  value="yes" '.($this->configs['cache_delext_js'] ? 'checked' : '').' disabled />'.$this->lang['extdesc_js'].'</label><br />');
          if ($this->configs['cache_delext_css'] < 0)
            ptln('      <input type="checkbox" name="delfl_css"  value="yes" checked />'.$this->lang['extdesc_css'].'</label><br />');
          else
            ptln('      <input type="checkbox" name="delfl_css"  value="yes" '.($this->configs['cache_delext_css'] ? 'checked' : '').' disabled />'.$this->lang['extdesc_css'].'</label><br />');
          if ($this->configs['cache_delext_mediaP'] < 0)
            ptln('      <input type="checkbox" name="delfl_mediaP"  value="yes" checked />'.$this->lang['extdesc_mediaP'].'</label><br />');
          else
            ptln('      <input type="checkbox" name="delfl_mediaP"  value="yes" '.($this->configs['cache_delext_mediaP'] ? 'checked' : '').' disabled />'.$this->lang['extdesc_mediaP'].'</label><br />');
          if ($this->configs['cache_delext_UNK'] < 0)
            ptln('      <input type="checkbox" name="delfl_UNK"  value="yes" checked />'.$this->lang['extdesc_UNK'].'</label><br />');
          else
            ptln('      <input type="checkbox" name="delfl_UNK"  value="yes" '.($this->configs['cache_delext_UNK'] ? 'checked' : '').' disabled />'.$this->lang['extdesc_UNK'].'</label><br />');
          if ($this->configs['cache_del_indexing'] < 0)
            ptln('      <input type="checkbox" name="del_indexing"  value="yes" />'.$this->lang['delindexingdesc'].'</label><br />');
          else
            ptln('      <input type="checkbox" name="del_indexing"  value="yes" '.($this->configs['cache_del_indexing'] ? 'checked' : '').' disabled />'.$this->lang['delindexingdesc'].'</label><br />');
          ptln('      </div>');
          ptln('      </div></form>');
        } else {
          ptln('      <p>'.$this->lang['cachedisabled'].'</p>');
        }
        ptln('    </th>');
        ptln('  </tr>');
        ptln('  <tr>');
        ptln('    <td class="leftalign"><br /></td>');
        ptln('  </tr>');
        ptln('  <tr>');
        ptln('    <th class="centeralign">');
        if ($this->configs['allow_allrevisdel'] == true) {
          ptln('      <form method="post" action="'.wl($ID).'" onsubmit="return confirm(\''.str_replace('\\\\n','\\n',addslashes($this->lang['askrevisions'])).'\')"><div class="no">');
          ptln('      <input type="hidden" name="do"   value="admin" />');
          ptln('      <input type="hidden" name="page" value="cacherevisionserase" />');
          ptln('      <input type="hidden" name="cmd"  value="eraseallrevisions" />');
          ptln('      <p>'.$this->lang['revisionsdesc'].'</p>');
          ptln('      <input type="submit" class="button" value="'.$this->lang['eraserevisionsbtn'].'" /><br />');
          ptln('      <div class="centeralign"><em>'.$this->lang['revisionswarn'].'</em></div>');
          ptln('      </div></form>');
        } else {
          ptln('      <p>'.$this->lang['revisdisabled'].'</p>');
        }
        ptln('    </th>');
        ptln('  </tr>');
        ptln('</table>');
      }

    }

    /**
     * delete all files into cache directory (specially coded for "data/cache" only)
     */
    function rmeverything_cache($fileglob, $basedir, $params)
    {
    	$fileglob2 = substr($fileglob, strlen($basedir));
        if (is_file($fileglob)) {
            if (strcmp($fileglob2, '/_dummy') == 0) return true;
            $pathinfor = pathinfo($fileglob2);
            if (strcmp($basedir, dirname($fileglob)) == 0) {
              if ($params & 0x02)  return true;
            } else {
              if (substr_count(strtolower($pathinfor['basename']), '.media.') > 0) {
                if ($params & 0x40) return true;
              } else if (strcmp(strtolower($pathinfor['extension']), 'i') == 0) {
                if ($params & 0x04) return true;
              } else if (strcmp(strtolower($pathinfor['extension']), 'xhtml') == 0) {
                if ($params & 0x08) return true;
              } else if (strcmp(strtolower($pathinfor['extension']), 'js') == 0) {
                if ($params & 0x10) return true;
              } else if (strcmp(strtolower($pathinfor['extension']), 'css') == 0) {
                if ($params & 0x20) return true;
              } else {
                if ($params & 0x01) return true;
              }
            }
            if (@unlink($fileglob)) {
                ptln("<strong>".$this->lang['deletefile']."</strong> <em>'".$fileglob2."'</em>.<br />");
                return true;
            } else {
                ptln("<strong>".$this->lang['deletefileerr']."</strong> <em>'".$fileglob2."'</em>.<br />");
                return false;
            }
        } else if (is_dir($fileglob)) {
            $ok = $this->rmeverything_cache("$fileglob/*", $basedir, $params);
            if (!$ok) {
                return false;
            }
            if (strcmp($fileglob, $basedir) == 0) return true;
            if (@rmdir($fileglob)) {
                ptln("<strong>".$this->lang['deletedir']."</strong> <em>'".$fileglob2."'</em>.<br />");
                return true;
            } else {
                return true;
            }
        } else {
            foreach (glob($fileglob) as $filename) {
                $this->rmeverything_cache($filename, $basedir, $params);
            }
        }
        return true;
    }

    /**
     * delete all files into old revisions directory (specially coded for "data/attic" only)
     */
    function rmeverything_revis($fileglob, $basedir)
    {
    	$fileglob2 = substr($fileglob, strlen($basedir));
        if (is_file($fileglob)) {
            if (strcmp($fileglob2, '/_dummy') == 0) return true;
            if (@unlink($fileglob)) {
                ptln("<strong>".$this->lang['deletefile']."</strong> <em>'".$fileglob2."'</em>.<br />");
                return true;
            } else {
                ptln("<strong>".$this->lang['deletefileerr']."</strong> <em>'".$fileglob2."'</em>.<br />");
                return false;
            }
        } else if (is_dir($fileglob)) {
            $ok = $this->rmeverything_revis("$fileglob/*", $basedir);
            if (!$ok) {
                return false;
            }
            if (strcmp($fileglob, $basedir) == 0) return true;
            if (@rmdir($fileglob)) {
                ptln("<strong>".$this->lang['deletedir']."</strong> <em>'".$fileglob2."'</em>.<br />");
                return true;
            } else {
                ptln("<strong>".$this->lang['deletedirerr']."</strong> <em>'".$fileglob2."'</em>.<br />");
                return false;
            }
        } else {
            foreach (glob($fileglob) as $filename) {
                $this->rmeverything_revis($filename, $basedir);
            }
        }
        return true;
    }

}

?>
